/* common Pandora GUI code base */
#include "../common/pangui.h"

/* packet library for spoof/sniff : LibNet/LibPCap  */
#include "../packet32/include/packet32.h"

/* NCP handling from NCPFS project by Volker Lendke */
#include "../ncp/include/ncplib.h"

/* the two variables below are declared localy, because they are */
/* used to call specific driver functions, and due to code optimization */
/* they need to be in the imediate memory space of this code */
LPADAPTER Pan_Adapter;
LPPACKET  Pan_Packet;
uint8  *buffer[151400],*buffer_pos=NULL; /* used in multi capture packet */
uint32 buffer_len,offset;

/* connection structure used in NCP send/receive/login */
struct ncp_conn *conn=NULL;
struct ncp_conn_spec *spec=NULL;

void StartPanServ()
{
 spec = calloc(1,sizeof(struct ncp_conn_spec));
 preference.default_server[0]='\0';
}

int GUI_Pan_NCP_connect()
{                      /* NULL for default server */

 const char *server = NULL;
 struct sockaddr_ipx addr;
 long err;

 /* let's see if we can attach to the server, in case we are */
 /* actually logged-in with a username */

 strncpy(spec->server,preference.default_server,NCP_BINDERY_NAME_LEN);

 if ((conn = ncp_open(spec, &err)) == NULL)
  {
   if (preference.default_server[0]) server=preference.default_server;
   else server=NULL;
   err = ncp_find_server(&server,
                         NCP_BINDERY_FSERVER,
                         (struct sockaddr*)&addr,
                         sizeof(addr));
   if (err) return(-400);

   conn = ncp_open_addr((struct sockaddr*)&addr, &err);
   if (err) return(-400);
  }
}

void GUI_Pan_NCP_disconnect()
{
 if(conn) ncp_close(conn);
}

int GUI_Pan_NCP_transmit(int func,uint8 *req,int rlengh,uint8 *ans,int alengh)
{
 long result;

 ncp_init_request(conn);
 if (req[2]) conn->has_subfunction=1;
 conn->current_size+=rlengh;

 memcpy(&(conn->packet[sizeof(struct ncp_request_header)]),req,rlengh);
 result = ncp_request(conn,func);
 memcpy(ans,ncp_reply_data(conn,0),alengh);

 ncp_unlock_conn(conn);
 return result;
}

int GUI_Pan_NCP_DoS(int func,uint8 *req,int rlengh,uint8 *ans,int alengh,
                    int rtime)
{
 int i;

 conn->current_size=sizeof(struct ncp_request_header);
 conn->current_size+=rlengh;

 memcpy(&(conn->packet[sizeof(struct ncp_request_header)]),req,rlengh);

 WSET_LH(conn->packet, 0, NCP_REQUEST);
 BSET(conn->packet, 2, conn->sequence);
 BSET(conn->packet, 3, (conn->i.connection) & 0xff);
 BSET(conn->packet, 5, (conn->i.connection) >> 8);
 BSET(conn->packet, 4, 1);
 BSET(conn->packet, 6, func);
 if (req[2])
  WSET_HL(conn->packet,7,
          conn->current_size-sizeof(struct ncp_request_header)-2);

 for(i=0;i<rtime;i++)
  {
   conn->sequence=((conn->sequence+1)&0Xff);
   send(conn->ncp_sock,conn->packet,conn->current_size,0);
  }
}

void StopPanServ()
{
 free(spec);
}

void GUI_Pan_Adapter_Names(char names[4][132])
{
 /* this will retreive up to four possible adapter names in your PC */
 /* if you have more than that, WELL FUCK, get a PC, not a server */
/*
 ULONG NameLength = 128;
 char AdaptersName[128];
 int i=0;
 #ifdef PAN_NT
 char string[128],*temp,*temp1;
 #endif
 #ifndef PAN_NT
 char *pointer;
 #endif

 memset(AdaptersName,0,128);
 memset(names[0],0,132);
 memset(names[1],0,132);
 memset(names[2],0,132);
 memset(names[3],0,132);




 PacketGetAdapterNames (AdaptersName,&NameLength);

 #ifdef PAN_NT
 temp=AdaptersName;
 temp1=AdaptersName;
 i=0;

 while ((*temp!='\0')||(*temp1!='\0'))
  {
   temp++;temp++;
   if (*temp=='\0')
    {
     memset(string,0,128);
     memcpy(string,temp1,temp-temp1);
     sprintUnicodeName(names[i],string,128);
     temp1=temp+2;
     i++;
    }
   if (i==5) break;
  }
 #endif

 #ifndef PAN_NT
 pointer=strtok(AdaptersName," ");

 while (pointer&&(i<4))
  {
   strcpy(names[i],pointer);
   pointer=strtok(NULL," ");
   i++;
  };
 #endif
*/
}

void GUI_Pan_RealTime_Adapter()
{
/*
 PacketSetBuff(Pan_Adapter,0);
*/
}

void GUI_Pan_Buffered_Adapter(int buffer_size)
{
/*
 PacketSetBuff(Pan_Adapter,buffer_size);
*/
}

int GUI_Pan_Open_Adapter(char *AdapterName)
{
/*
 Pan_Adapter=NULL;

 #ifdef PAN_NT
 MakeUnicodeName(AdapterName);
 #endif
 
 Pan_Adapter=PacketOpenAdapter(AdapterName);
 if (Pan_Adapter && (Pan_Adapter->hFile!=INVALID_HANDLE_VALUE))
  {
   PacketSetHwFilter(Pan_Adapter,NDIS_PACKET_TYPE_PROMISCUOUS);
   PacketSetBuff(Pan_Adapter,0); 
*/
   /* default behavior : no buffering */
/*
   Pan_Packet=PacketAllocatePacket();
  }
 else return(-206);
 return(0);
*/
}

void GUI_Pan_Close_Adapter()
{
/*
 if (Pan_Adapter)
  {
   PacketFreePacket(Pan_Packet);
   PacketSetHwFilter(Pan_Adapter,0);
   PacketResetAdapter(Pan_Adapter);
   PacketCloseAdapter(Pan_Adapter);
  }
*/
}

void GUI_Pan_Spoof_One(uint8 *Pan_buffer, uint32 length)
{
/*
 PacketInitPacket(Pan_Packet,(BYTE*)Pan_buffer,(unicode)length);
 Pan_Packet->ulBytesReceived=length;
*/ 
 /* BUG IN NT DRIVER */
/*
 PacketSendPacket(Pan_Adapter,Pan_Packet,TRUE);
*/
}

void GUI_Pan_Sniff_One(uint8 Pan_buffer[MAX_PACKET_LENGTH], uint32 *length)
{
/*
 PacketInitPacket(Pan_Packet,(BYTE*)Pan_buffer,MAX_PACKET_LENGTH);
 PacketReceivePacket(Pan_Adapter,Pan_Packet,TRUE); 
*/
/* will hold until received */
/*
 *length=Pan_Packet->ulBytesReceived;
*/
}

void GUI_Pan_Sniff_from_Multi(uint8 Pan_buffer[MAX_PACKET_LENGTH], uint32 *length)
{
/* struct bpf_hdr *header; */

 /* if buffer_pos is set to NULL we're in the situation of an empty user space */
 /* buffer : i.e first time sniffing or buffer fully treated, we need to get */
 /* fresh data */

/*
 if (!buffer_pos)
  {
   PacketInitPacket(Pan_Packet,(BYTE*)buffer,151400);
   PacketReceivePacket(Pan_Adapter,Pan_Packet,TRUE); 
*/
   /* will hold until received */
/*
   buffer_pos=Pan_Packet->Buffer;
   buffer_len=Pan_Packet->ulBytesReceived;
   offset=0;
  }
*/
 /* grab packet header */
/*
 header=(struct bpf_hdr *)(buffer_pos+offset);
*/
 /* total current packet length */
/*
 *length=(header->bh_hdrlen)+(header->bh_datalen);
*/
 /* copy all data */
/*
 memcpy(Pan_buffer,buffer_pos+offset,*length);
*/
 /* move to next packet */
 /* offset+=*length; change since V2->V2.1 of driver */
/*
 offset=Packet_WORDALIGN(offset+(*length));

 if (offset>=buffer_len) buffer_pos=NULL;
*/
}
